//******************************************************************************************
// FlashCard 	-A widget to create FlashCards
// 				A sample widget created for SMART by digiXL
//				This widget allows the user to create a flash crad with two faces
//				that can have text and/or image on either side
//				Created - Mar 21 2012
//******************************************************************************************
	
// TODO:: move all coordinates inside code to constants class
$(function() {
	var bgCol=143;
	var firstEdit=true;
	//FLIP_SPEED:  the duration of the flip transition from 9 to 90 deg (total flip time will by FLIP_SPEED x 4
	var FLIP_SPEED="600ms";
		  
	//widget : reference to the widget notebook object
	var widget=NB.getObject(NB.HOSTGUID);
    widget.moveToBack();
	
	// editMode is the app state true when the flashcard is being edited and false when in flip mode
	var editMode= false;
	
	var flipping=false;
	
	var browser=false;
	
	//activeFace determines the currently "on top" face of the FlipCard
	var activeFace="front";
	
	// flipDir - we are providing two flip directions - horiz and vert
	var flipDir="vert";
	
	//origHeight and origWidth are used to store the original size of inserted image to help maintain its proportions
	var origHeight=220;
	var origWidth=320;
	
	var transitionIndex=0;
	
	var dragging=false;
	var startX;
	var startY;
	var widgetX;
	var widgetY;
	
	
		  
	//***********************************************************
	// function getImage
	// captures image data from the dropped object XML and injects into the widget XML
	//***********************************************************
	function getImage(guid) {
		
		var obj=null;
		var objects=NB.page.getObjects();
		obj=objects[guid];
		
		if (obj.type=="widget") return false;
		if (obj.type=="ink") return false;
		if (obj.type=="group") return false;
		
		//alert(obj.type);
		var stringXML =  obj.toXML()
		if (obj.type!="image") {			
			var w = obj.width;
			var h = obj.height;
			
			var sf;
			if (416/w>273/h) {
				sf=273/h;
			} else {
				sf=416/w;
			}
			sf=sf*0.8;
			var wx=parseInt(w*sf);
			var hx=parseInt(h*sf);
		
		//	var strx='<svg width="'+'100%'+'" height="'+'100%'+'" viewBox="'+obj.x+' '+ obj.y+' '+w+' '+h+'">'+ stringXML + '</svg>';
			
			document.getElementById("image-container-"+activeFace).style.backgroundImage='url(\'data:image/svg+xml;utf8,<svg xmlns="http://www.w3.org/2000/svg" width="'+wx+'" height="'+hx+'" viewBox="'+obj.x+' '+ obj.y+' '+w+' '+h+'">'+ stringXML + '</svg>\')';
		} else {
			var parser = new DOMParser();
			var xmldoc = parser.parseFromString(stringXML, 'text/xml');
		
			var w = parseInt(xmldoc.getElementsByTagName("image")[0].getAttribute("width"));
			var h = parseInt(xmldoc.getElementsByTagName("image")[0].getAttribute("height"));
			var base64_data = xmldoc.getElementsByTagName("image")[0].getAttribute("xlink:href");
			var sf;
			if (416/w>273/h) {
				sf=273/h;
			} else {
				sf=416/w;
			}
			sf=sf*0.8;
			var wx=parseInt(w*sf);
			var hx=parseInt(h*sf);
			 document.getElementById("image-container-"+activeFace).style.backgroundImage='url('+base64_data+')';		
		}
		document.getElementById("image-container-"+activeFace).style.backgroundSize=wx+' '+hx;
		document.getElementById("image-container-"+activeFace).setAttribute("data-origwidth",wx);
		document.getElementById("image-container-"+activeFace).setAttribute("data-oright",hx);
		
		 NB.page.deleteObject(obj);
		 updateDisplay();
		 return true;
	}
	  
	//***********************************************************
	// function resizeCard
	// handles widget resize
	//***********************************************************
	
	function resizeCard() {
		
		//if (editMode) return;
		
		var scaleX=(window.innerWidth)/461;
		var scaleY=(window.innerHeight)/350;
		
		NB.beginBatch();
		
		$("#flip-container").css({webkitTransform:'scale('+scaleX+','+scaleY+')'});
		$("#flip-container").offset({left:22*scaleX,top:12*scaleY});
		$("#cardbase").css({webkitTransform:'scale('+scaleX+','+scaleY+')'});
		//$("#cardbase").offset({top:252*scaleY});
		//alert($("#editor").height());
		$("#inkpad").height(35*scaleY);
		$("#inkpad").offset({top:window.innerHeight-$("#inkpad").height()-18});
		
		$("#edit-button").offset({left:34*scaleX,top:245*scaleY});
		$("#kill-button").offset({left:403*scaleX,top:22*scaleY});
		//$("#flip-button").offset({left:35*scaleX,top:230*scaleY});

		//alert($("#editor").offset().top);
		var sfx=1;
		if (window.innerWidth<385) {
			var sfx=window.innerWidth/385;
			
		} 
		$("#editor").css({webkitTransform:'scale('+sfx+','+sfx+')'});
		//$("#editor").css({webkitTransform:'scale(1,1)'});
		
		
		$("#editor").offset({left:55*scaleX,top:$("#inkpad").offset().top-64*sfx-4});
		NB.endBatch();
	}
	
	//***********************************************************
	// function toggleEditMode
	// show or hide the edit controls
	//***********************************************************
	function toggleEditMode(evt) {
		
		if (editMode) {
			saveData();
			$("#editor").hide();
			$("#inkpad").hide();
			editMode=false;
			$("#text-container-"+activeFace).attr('contentEditable',false);
			$("#text-container-"+activeFace).css('cursor','default');
			$("#text-container-"+activeFace).css('-webkit-user-select','none');
			
			
		} else {
			editMode=true;
			$("#text-container-"+activeFace).css('cursor','auto');
			$("#text-container-"+activeFace).attr('contentEditable',true);
			$("#text-container-"+activeFace).css('-webkit-user-select','auto');
			showEditor();
		}
	}
	
	function showEditor() {
        var tmp = $("#text-container-front").text();
		if (tmp.indexOf("then enter text or drag and drop image") != -1) {
			$("#text-container-front").html("");
			
		}
        tmp = $("#text-container-back").text();
		if (tmp.indexOf("then enter text or drag and drop image") != -1) {
			$("#text-container-back").html("");
			
		}
		firstEdit=false;
		var node = $("#flip-container")[0];
		var curTransform = new WebKitCSSMatrix(window.getComputedStyle(node).webkitTransform);
		$("#inkpad").offset({top:window.innerHeight-$("#inkpad").height()-18});
		
		$("#inkpad").show();
		var scaleX=(window.innerWidth)/461;
		var scaleY=(window.innerHeight)/350;
		var sfx=1;
		if (window.innerWidth<385) {
			var sfx=window.innerWidth/385;
			
		} 
		$("#editor").css({webkitTransform:'scale('+sfx+','+sfx+')'});
		$("#editor").show().offset({left:55*scaleX,top:$("#inkpad").offset().top-64*sfx-4});
		$("#text-container-"+activeFace).focus();
	}
	
	//***********************************************************
	// function doFlip
	// performs the flip of the cards
	//***********************************************************
	
	function doFlip() {
		
		if (flipping) return;
		$("#kill-button").hide();
		$("#edit-button").hide();
		//$("#flip-button").hide();
		 $("#flip-card").css("-webkit-transition-duration",FLIP_SPEED);
		var rotateDir="rotateX";
		if (flipDir=="horiz")  rotateDir="rotateY";
		flipping=true;
		if(transitionIndex == 0) {		  
	      $("#flip-card").css({webkitTransform:rotateDir+'(90deg)'});
	   } else {
		  $("#flip-card").css({webkitTransform:rotateDir+'(270deg)'});
	   }
	}
	 $("#flip-card").bind('webkitTransitionEnd', function(){
		  var rotateDir="rotateX";
		if (flipDir=="horiz")  rotateDir="rotateY";
		   if(transitionIndex == 0){
			   //we have to show the backface
			    $("#card-back").css("display","block");
			 	$("#card-front").css("display","none");
				//$("#flip-card").unbind('webkitTransitionEnd');
			 	$("#flip-card").css({webkitTransform:rotateDir+'(180deg)'});
				
		   } else if(transitionIndex == 1){ 
				flipping=false;
				activeFace="back";
           	 	
				updateDisplay();
				$("#kill-button").show();
				$("#edit-button").show();
		   } else if(transitionIndex == 2){
				$("#card-back").css("display","none");
				$("#card-front").css("display","block");
				
				$("#flip-card").css({webkitTransform:rotateDir+'(360deg)'});
            
        } else if(transitionIndex == 3){
				$("#flip-card").css("-webkit-transition-duration","0ms");
				$("#flip-card").css({webkitTransform:rotateDir+'(0deg)'});
				activeFace="front";
				transitionIndex=-1;
				flipping=false;
				updateDisplay();
				$("#kill-button").show();
				$("#edit-button").show();
        }
		transitionIndex++;
    });
	function doEditFlip() {
		$("#text-container-"+activeFace).attr('contentEditable',false);
		$("#text-container-"+activeFace).css('cursor','default');
		$("#text-container-"+activeFace).css('-webkit-user-select','none');
		var otherFace="back";
		if (activeFace=="back") otherFace="front";
		$("#text-container-"+otherFace).attr('contentEditable',true);
		$("#text-container-"+otherFace).css('cursor','auto');
		$("#text-container-"+otherFace).css('-webkit-user-select','auto');
		
		doFlip();		
	}
	function updateDisplay() {
		var bkim=$("."+activeFace).css("background-image");
		bkim.replace(".png","_th.png");
		$("#bkimage").css('background-image',bkim);
		 var bkcol=$("."+activeFace).css("background-color");
		// alert(bkcol);
		$("#color2").attr("title",bkcol);
		$("#color2").change();
		
		var img=$("#image-container-"+activeFace).css("background-image");
	  
	  if (img==null || img=="none") {
		$("#imgmsg").show();
		$("#imgul").hide();
		}
		else {	
		$("#imgmsg").hide();
		$("#imgul").show();
		}
	}
	//drag functionality not completed yet
	function startDrag(evt) {
		
		dragging=true;
		startX=evt.pageX;
		startY=evt.pageY;
		
		widgetX=widget.x;
		widgetY=widget.y;
	}
	function dragWidget(evt) {
		
		//evt = evt ? evt : window.event;
		if (dragging) {
			
		widget=NB.getObject(NB.HOSTGUID);
		var sx=evt.pageX;
		var sy=evt.pageY;
		var nx=sx-startX;
		var ny=sy-startY;
		
		//alert("move"+evt.pageX);
		widget.x=widgetX+nx;
		widget.y=widgetY+ny;
		
		startX=sx;
		startY=sy;
		
		widgetX=widget.x;
		widgetY=widget.y;
		}
		
	}
	function endDrag() {
		dragging=false;
	}
	
	
   $("#flip-card").click(function() {
	  if (editMode) return;
	   doFlip();
   });
   
   
 	//***********************************************************
	// function setFlipDirection
	// sets the current flip direction ot horiz or vert
	// and sets the back card transformations accordingly
	//***********************************************************
   function setFlipDirection(evt) {
	 flipDir=$(this).val();
	 $("#flip-card").css("-webkit-transition-duration","0ms");
	 if (flipDir=="horiz") {
	if (activeFace=="back") {
			  $("#flip-card").css("webkitTransform","rotateY(0deg)");
			  $("#flip-card").css("webkitTransform","rotateX(0deg)");
		  }
		 $(".back").css("webkit-transform","rotateX(0deg)");
		  $(".back").css("webkit-transform","rotateY(180deg)");
		  if (activeFace=="back") {
			  $("#flip-card").css("webkitTransform","rotateY(180deg)");
		  }
	 } else {
		 if (activeFace=="back") {
			  $("#flip-card").css("webkitTransform","rotateY(0deg)");
			  $("#flip-card").css("webkitTransform","rotateX(0deg)");
		  }
		 $(".back").css("webkit-transform","rotateY(0deg)");
		  $(".back").css("webkit-transform","rotateX(180deg)");
		  if (activeFace=="back") {
			 
			  $("#flip-card").css("webkitTransform","rotateX(180deg)");
		  }
	 }
	 $(this).toggleClass("selected");
   }
   function setTextSelection() {
	    if (document.getSelection()=="")  {
			$("#text-container-"+activeFace).focus();
			 document.execCommand("SelectAll",false);
			 return false;
		}
		else return true;
   }
  
  	//***********************************************************
	// function execEditButton
	// we are using a contenteditable div for the editable text
	// formatting on this is done by running the execCommand 
	// and providing it the command to execute e.g. bold or italics etc.
	//***********************************************************
 
  function execEditButton() {
	  if ($(this).attr("title")=="delete") {
		  $("#image-container-"+activeFace).css("background-image","none");
		  updateDisplay();
	  } else if ($(this).attr("title")=="deletetext") {
		 
		 $("#text-container-"+activeFace).html("");
		 
	  } else{
		  var sel=setTextSelection();
		   document.execCommand($(this).attr("title"),null,false);
	  }
   }

	//***********************************************************
	// function setFontFace
	// set the text font
	//***********************************************************
   
   function setFontFace(evt) {
	  setTextSelection();
	    document.execCommand("fontname",null,$(this).attr("value"));
   }

	//***********************************************************
	// function setFontSize
	// set the text font size
	//***********************************************************
   
    function setFontSize() {
		setTextSelection();
	    document.execCommand("fontsize",false,$(this).attr("value"));
   }
   
	//***********************************************************
	// function showBkImgSelector
	// show the selection menu for selecting a card background image
	//***********************************************************
   function showBkImgSelector() {
	   $(".imagemenu").css({
                top: $(this).offset().top-$(".imagemenu").outerHeight()
            });
			
		if ($(".imagemenu").css('display')=='block') {
			  $(".imagemenu").hide();
			   $(document.body).unbind("mousedown",checkImgMouse);
		} else {
			 $(document.body).bind("mousedown",checkImgMouse);
			   $(".imagemenu").show();
		}
	 
   }
	//***********************************************************
	// function setCardBk
	// apply selected background ot the active card face
	//***********************************************************
   function setCardBk(evt) {
	   var otherFace="back";
		if (activeFace=="back") otherFace="front";
		
	  if ($(this).attr("class")=="back0") {
		   $("."+activeFace).css('background-image','none');
		    $("#bkimage").css('background-image','none) ');
	  } else {
		  var oldBk=$("."+otherFace).css('background-image');
		  
		  var oldStyle=oldBk.substr(oldBk.indexOf(".png")-3,1);
		  
		   $("."+activeFace).css('background-image','url(styles/'+$(this).attr("class")+'.png) ');
		   $("#bkimage").css('background-image','url(styles/'+$(this).attr("class")+'_th.png)');
		   
		   
		   var styleX=$(this).attr("class");
		   styleX=styleX.substr(styleX.length-3,1);
		   $("#cardbase").css('background-image','url(styles/style'+styleX+'-bk.png)');
		   if (oldStyle!=styleX) {
			 $("."+otherFace).css('background-image','url(styles/'+$(this).attr("class")+'.png) ');
		  	 
		   }
	  }
	  //alert("BGGGGGGG"+$("."+activeFace).css('background-image'));
	     $(".imagemenu").hide();
		 $(document).unbind("mousedown",checkImgMouse);
   }
  function checkImgMouse(){	 
	  var selectorParent = $(event.target).parents(".imagemenu").length;
	  if (selectorParent>0 ||  (event.target.className)=="imagemenu") {
                return;
            }
            $(".imagemenu").hide();
			$(document.body).unbind("mousedown",checkImgMouse);
			event.stopPropagation();
   }
   
	//***********************************************************
	// function setImageSize
	// set image size as per the range selector
	//***********************************************************
  function setImageSize() {
	   var pcent=parseInt($("#img-size").val())/100;
	   var wx=parseInt(document.getElementById("image-container-"+activeFace).getAttribute("data-origwidth"))*pcent;
	   var hx=parseInt(document.getElementById("image-container-"+activeFace).getAttribute("data-oright"))*pcent;
	   $("#image-container-"+activeFace).css("background-size",wx+" "+hx);
   }
   
	//***********************************************************
	// function applyFormat
	// applies format of loaded data to the given card face
	//***********************************************************
   function applyFormat(face,faceObj) {
	   $("#text-container-"+face).html(faceObj.text);
	  //alert(faceObj.bkImg);
	  //background
	  $("."+face).css("background-color",faceObj.bkColor);
	  $("."+face).css("background-image",faceObj.bkImg);
	  
	  //image
	  $("#image-container-"+face).css("background-image",faceObj.img);
	  if (faceObj.img!="none") {
	  	$("#image-container-"+face).css("background-size",faceObj.imgSz);
		document.getElementById("image-container-"+activeFace).setAttribute("data-origwidth",faceObj.imgOrigWid);
		document.getElementById("image-container-"+activeFace).setAttribute("data-oright",faceObj.imgOrigHt);
	  }
   }
   
	//***********************************************************
	// function loadData
	// loads data saved through NB.persist
	//***********************************************************
  function loadData() {
  if (NB.persist.list()==null) return;
	  
	  var flip=NB.persist.load("FLIPCARDv1");
		//alert(flip);
		if (flip==null || flip=="undefined") return;
	  var flipObj=JSON.parse(flip);
	  //text
	// alert(flipObj.front);
	  applyFormat("front",flipObj.front);
	  applyFormat("back",flipObj.back);
	
	  flipDir=flipObj.flipDirection;
	  //alert(flipObj.cardBase);
	  
	  $("#flip"+flipDir).attr('checked', true);
	  $("#cardbase").css("background-image",flipObj.cardBase);
	   $("#flip-card").css("-webkit-transition-duration","0ms");
	  if (flipDir=="horiz") {
		
		 $(".back").css("webkit-transform","rotateX(0deg)");
		 $(".back").css("webkit-transform","rotateY(180deg)");
		
	 } else {
		 
		 $(".back").css("webkit-transform","rotateY(0deg)");
		 $(".back").css("webkit-transform","rotateX(180deg)");
		 
	 }
	 
	  
  }
  function stripURL(str) {
	  newStr=str;
	  if (str.indexOf("http")!=-1) {
		  newStr='url('+str.substr(str.indexOf("styles"));
	  }
	  return newStr;
  }
  
	//***********************************************************
	// function CardFace
	// defines and initiallzes a cardface object as per css values
	//***********************************************************
  function CardFace(face) {
	  //text
	  this.text=$("#text-container-"+face).html();
	  
	  //background
	  this.bkColor=$("."+face).css("background-color");
	  this.bkImg=$("."+face).css("background-image");
	  if (this.bkImg==null) this.bkImg="none";
	 
	  //digiXL Feb5-2013 - fix for missing images when widget is added/loaded
	  this.bkImg=stripURL(this.bkImg);
	  
	  //image
	  this.img=$("#image-container-"+face).css("background-image");
	   
	  if (this.img==null || this.img=="none") {
		  this.img="none";
	  } else {
	  	this.imgSz=$("#image-container-"+face).css("background-size");
		this.imgOrigWid=document.getElementById("image-container-"+activeFace).getAttribute("data-origwidth");
		this.imgOrigHt=document.getElementById("image-container-"+activeFace).getAttribute("data-oright");
	  }
	  
  }
	//***********************************************************
	// function FlipCard
	// defines the flipcard object with two faces - front and back
	//***********************************************************
	  function FlipCard(){
		 this.front= new CardFace("front");
		 this.back=new CardFace("back");
		 //alert(this.front.img);
		 this.flipDirection=flipDir;
		 this.cardBase=$("#cardbase").css("background-image");
		 
		 //digiXL Feb5-2013 - fix for missing images when widget is added/loaded
	  	 this.cardBase=stripURL(this.cardBase);
		 
	  }
  
  
	//***********************************************************
	// function saveData
	// save the data through NB.persists
	//***********************************************************
  function saveData() {
	 var flip=new FlipCard();
	 NB.persist.save("FLIPCARDv1", flip);	  
  }
  
  
  // Add an observer that listens for a drop and add events
	var chkForDrop = function(evt) {
		// we need to check for drag drop only if we are in the edit mode!
		if (!editMode) return;
		
		widget=NB.getObject(NB.HOSTGUID);
		 
		// From here, based on the event, you can do a hit test.
		for(var guid in evt.eventData) {
		  var contact=evt.eventData[guid].contact;
		  if(widget.contains(contact.x, contact.y)) {
			var placed=getImage(guid);
			if (placed) break;
		  }	  
		}
	};
	  
	var chkForAdd = function(evt) {
		// we need to check for drag drop only if we are in the edit mode!
		if (!editMode) return;
		
		widget = NB.getObject(NB.HOSTGUID);
		// From here, based on the event, you can do a hit test.
		var ann = NB.getObject(evt.eventData.guid);
		if (widget.contains(ann.x + ann.width / 2, ann.y + ann.height / 2)) {
			var placed = getImage(evt.eventData.guid);
			if (placed) return;
		}
	};
	  
	function insertTextAtCursor(html) {
		var sel, range;

		if ($(document.activeElement)!=$("#text-container-"+activeFace))  $("#text-container-"+activeFace).focus();
		
		var sel, range;
   		if (window.getSelection) {
        // IE9 and non-IE
        sel = window.getSelection();
          if (sel.getRangeAt && sel.rangeCount) {
            range = sel.getRangeAt(0);
            range.deleteContents();

            // Range.createContextualFragment() would be useful here but is
            // non-standard and not supported in all browsers (IE9, for one)
            var el = document.createElement("div");
            el.innerHTML = html;
            var frag = document.createDocumentFragment(), node, lastNode;
            while ( (node = el.firstChild) ) {
                lastNode = frag.appendChild(node);
            }
            range.insertNode(frag);
            
            // Preserve the selection
            if (lastNode) {
                range = range.cloneRange();
                range.setStartAfter(lastNode);
                range.collapse(true);
                sel.removeAllRanges();
                sel.addRange(range);
            }
        }
      } 
	}
	//recognize related functions
	var invalidTimer = -1
	var currentWaitingTimer = invalidTimer;
	var alreadyInvalid = false;

	var textEntryOffset = 285;

	NB.addObserver("inkingEvent", function (evt) {
		if(alreadyInvalid) return;

		if(currentWaitingTimer == invalidTimer) {
			if(NB.getObject(NB.HOSTGUID).contains(evt.eventData.x, evt.eventData.y - textEntryOffset)) {
				if(document.getElementById("inkpad").innerHTML != "...") {
					$("#inkpad").css('background-image','none');
					document.getElementById("inkpad").innerHTML = "...";
					document.getElementById("inkpad").style.border = "2px solid #29f"
					hostObj.x = hostObj.x + 1
				}
			}
		}

		alreadyInvalid = true;
	});

    NB.addObserver("inkingFinishedEvent", function (evt) { 
		alreadyInvalid = false;

		if(document.getElementById("inkpad").innerHTML != "...") {
			return;
		}

		// Fire a call back after 3 seconds of no waiting
		var secondsToWait = 2;

		if(currentWaitingTimer != invalidTimer) {
			clearTimeout(currentWaitingTimer);
			currentWaitingTimer = invalidTimer;
		}

		currentWaitingTimer = setTimeout(onFinishedText, secondsToWait * 1000);
		console.log(evt.eventData.guid);

		// This changes if something weird is going on
		// console.log(NB.page.getObjectsAsArray().length);
	}); 
   
   	function onFinishedText()
	{
		currentWaitingTimer = invalidTimer;
		//document.getElementById("inkpad").innerHTML = "Write here";
		document.getElementById("inkpad").innerHTML = "";
		$("#inkpad").css('background-image','url(assets/write.png) ');
		document.getElementById("inkpad").style.border = "1px solid #000"

		// Get the last annotation
		var objs = NB.page.getObjectsAsArray();
		if(objs.length < 2) return;
		var obj = objs[objs.length - 1];

		console.log(obj.getText());

		hostObj = NB.getObject(NB.HOSTGUID)    

		if(!hostObj.contains(obj.x, obj.y - textEntryOffset)) {
			console.log("Got text but didn't hit");
			return;
		}
		
		insertTextAtCursor(obj.getText()+"&nbsp;");

        obj.animation.start({ speed: "Fast", repeats: "None", type: "Fade Out" });

		hostObj.x = hostObj.x + 1
	}

    NB.addObserver("annotationFinishedAnimatingEvent", function (evt) {
		var obj = NB.getObject(evt.eventData.guid);
		NB.page.deleteObject(obj);
		console.log(evt);	
 	}); 
	//end recognize functions
	
	
	
	function showTxtControls() {
		$("#imageControls").hide();
		$("#textControls").show();
	}
	function showImgControls() {
		$("#imageControls").show();
		$("#textControls").hide();
	}
		
	function setupEditorControls() {
		//text controls
		
		$(".editbarBut a").click(execEditButton);
		$("#fontfc").change(setFontFace);
		$("#fontsz").change(setFontSize);
		
		//image controls
		 $("#img-size").change(setImageSize);
		
		//style controls
		$("#bkimage").click(showBkImgSelector);
		$(".imagemenu li").click(setCardBk);
		$("input:radio[name=flipdir-radio]").click(setFlipDirection);
		
		$("#flip-button").click(doEditFlip);
		
		$(".txticon").click(showTxtControls);
		$(".imgicon").click(showImgControls);
		
	}
	function killWidget(evt) {
		widget=NB.getObject(NB.HOSTGUID);
		NB.page.deleteObject(widget);
	}
	function nextBg() {
		bgCol--;
		//$(document.body).css();
		 NB.settings.enableTransparentColorMask(bgCol, bgCol, bgCol);
		 $("#text-container-front").html(""+bgCol)
	}
	function init() {
	   NB.settings.enableTransparentColorMask(bgCol, bgCol, bgCol);
	//  $(document.body).click(nextBg);
	   NB.addObserver("dndDropEvent", chkForDrop);
	   NB.addObserver("annotationAddedEvent", chkForAdd);
	   window.addEventListener('resize', resizeCard, false);


		 $('#color1').colorPicker();
		 $('#color2').colorPicker();
		 
		 $('#color1').bind("change", function () {
			setTextSelection();
			document.execCommand("foreColor",null,$(this).attr("title"));
		 });
		 $('#color2').bind("change", function () {
			$('.'+activeFace).css("background-color",$(this).attr("title"));
		 });
		 $("#kill-button").click(killWidget);
		 $("#edit-button").click(toggleEditMode);
		 setupEditorControls();
		 $('#color2').attr("value","#FF6");
		 loadData();
		 updateDisplay();
		 $("#flip-container").show();
		 resizeCard();
  }
  init();
	      
 });
 
 
	  
	  